var USER = localStorage.getItem( 'USER' ) && JSON.parse( localStorage.getItem( 'USER' ) );  
    

var APP = {
    appId: 'hongbei',

    // 获取当前文件相对根目录地址
    path: function(){
        var _url = location.href;
        if( _url.indexOf( this.appId ) === -1 ){
            this.appId = _url.match(/A\d{6,}\//)[0];
            return _url.substring( _url.indexOf( this.appId ) + this.appId.length, _url.indexOf( '.html' ) );
        }else{
            return _url.substring( _url.indexOf( this.appId )+this.appId.length+1, _url.indexOf( '.html' ) );
        }
    },

    // 相对与跟目录层级
    relativePath: function(){
        var _num = this.path().match( /\//g );
        return _num ? (function(){
            var _path = '';
            for( var x in _num ){
                _path+='../';
            };
            return _path;
        })() : './'
        // return .length;
    },

    // 获取当前文件名称
    name: function(){
        var _name = this.path().split( '/' );
        return {
            name: _name[ _name.length - 1 ].split( '.' )[0],
            folder: _name[ _name.length - 2 ]  
        };
    },

    // 获取当前窗口属性
    properties: function(){
        var _name = this.name().name.split( '_' ),
            _css = document.querySelector( 'link[src]' );
        return {
            hasWin: _name[ _name.length - 1 ] === 'win',
            // name: typeof CSSFile === 'undefined' ? _name[0] : CSSFile
            name: _css ? _css.getAttribute( 'src' ) : _name[0]
        };
    },

    // 字段是否为空
    hasEmp: function( val ){
        return typeof val !== 'undefined';
    },

    // 获取当前窗口样式文件
    style: function(){
        return '<link rel="stylesheet" type="text/css" href="'+this.relativePath()+'css/'+this.properties().name+'.css" />'
    },

    fixIos7Bar: function(el) {
        var strDM = api.systemType;
        if (strDM == 'ios') {
            var numSV = parseInt(api.systemVersion, 10);
            var fullScreen = api.fullScreen;
            var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
            if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
                el.style.paddingTop = '20px';
            }
        }
    },
    
    fixStatusBar: function(el) {
        var sysType = api.systemType;
        if (sysType == 'ios') {
            u.fixIos7Bar(el);
        } else if (sysType == 'android') {
            var ver = api.systemVersion;
            ver = parseFloat(ver);
            if (ver >= 4.4) {
                el.style.paddingTop = '25px';
            }
        }
    },

    loadSuccess: function( cb ){
//      if( window.api ){
        window.app = angular.module('myApp', []);
		angInit = function($scope, $http, $location, $timeout){
            window.$timeout = $timeout;
            apiready = function(){
                var _header = $( 'header' )[0] || $( '.header' )[0];
                if( _header ){
                    APP.fixStatusBar( $( _header )[0] );
                }
                cb && cb( $scope, $http, $location, $timeout, api.pageParam );
            }

                cb && cb( $scope, $http, $location, $timeout );
        }  
//      }else{
//          angInit = function($scope, $http, $location, $timeout){
//              window.$timeout = $timeout;
//              cb && cb( $scope, $http, $location, $timeout );
//          }   
//      }
    }

};

document.head.insertAdjacentHTML('beforeend', APP.style());

var vGlobalInput = null;
function fnInput( el, selector ){
    vGlobalInput = el;
    if( $.trim( $( el ).val() ).length ){
        if( ! $( el ).parent().find( '.ic_input_close' ).length ){
            $( el ).parent().append( '<div tapmode onclick="fnEmptyInput( this );" class="ic_input_close"></div>' );
        }
        if( selector ){
            $( selector ).html( $( el ).attr( 'data-num' ) - $.trim( $( el ).val() ).length )
        }
    }else{
        $( el ).parent().find( '.ic_input_close' ).remove();
    }
}

function fnEmptyInput( el ){
    event.stopPropagation();
    $( vGlobalInput ).val( '' )
    fnInput( $( vGlobalInput )[0] )
}

function fnOpen( el ){
	var _path = $( el ).attr( 'data-path' ).split( '/' );
    debugAlert( _path )
    fnOpenWin({
        name: _path[1],
        folder: _path[0],
        bgColor: _path[2]
    });
}
    
    
function fnOpenWin( obj ){
//  if( window.api ){
        if( ! obj.name ){
            obj.name = api.winName.replace( /_win$/, '_frm');
            obj.folder = APP.name().folder;
        }
    	var vParam = {
            name: obj.name,
            url: 'widget://html/' + obj.folder + '/' + obj.name + '.html',
            pageParam: obj.pageParam,
            delay: obj.delay || 300,
            bgColor: obj.bgColor || '#f0f0f0',
            animation: obj.animation || null
        };
        if( obj.debug )debugAlert( vParam );
        if( /_frm$/g.test( obj.name ) ){
        	delete vParam.bgColor;
            obj.rect && (vParam.rect = obj.rect);
            api.openFrame( vParam );
        }else{
            api.openWin( vParam );
        }
//  }
}

function debugAlert(){
    if( true ){
        var vTemp = []; 
        for( var x in arguments ){
            vTemp.push( arguments[x] );
        }
        vTemp = JSON.stringify( vTemp );
        alert( vTemp.substring( 1, vTemp.length-1) );
    }
}

function fnToast( _txt ){
    if( window.api ){

    }else{
        alert( _txt );   
    }
}


// 验证
function fnVerify( type ) {
    if( type === 'Email' ){
        return /^(\w-*\.*)+@(\w-?)+(\.\w{2,})+$/;
    }else if( type === 'Phone' ){
        return /^1\d{10}$/;
    }else if( type === 'Tel' ){
        return /^0\d{2,3}-?\d{7,8}$/;
    }
};

function fnAjax( obj, cb){
    var _param = {
        type: obj.method || ( obj.data ? 'POST' : 'GET' ),
        url: 'http://www.ambaker.cn/api/'+obj.url,
        // post payload:
        data: obj.data,
        dataType: 'json',
        success: function( success ){
            obj.debug && console.log( arguments );
            window.$timeout(function(){
                cb && cb( success );
            }, 10);
        },
        error: function( err ){
            obj.debug && console.log( arguments );
            window.$timeout(function(){
                cb && cb( err );
            }, 10);
        }
    };
    obj.debug && console.log( _param );
    $.ajax(_param);
}

function fnLanguage( _val ){
    return _val;
}

function fnSelector( _title, _data, cb){
    var scope = [];
    if( _data instanceof Array ){
        for( var x in _data ){
            scope.push({
                value: _data[x].value || _data[x].name || _data[x],
                id: _data[x].id || _data[x]
            });
        }
    }else{
        for( var x in _data ){
            scope.push({
                value: fnLanguageSwitch( _data[x] ),
                id: x,
                _data: JSON.stringify( _data[x] )
            });
        }
    }
    new IosSelect(1, [scope],{
        container: 'body',
        title: _title,
        itemHeight: 50,
        itemShowCount: 3,
        // endback: function( ret ){
        //     cb && cb( ret );
        // }
        callback: function ( ret ) {
            cb && cb( ret );
        }
    });
};
