var USER = localStorage.getItem( 'USER' ) && JSON.parse( localStorage.getItem( 'USER' ) );  


var _SEX = [{
    id: 1,
    name: '男'
},{
    id: 2,
    name: '女'
}];

var GLOBAL_TOPIC = '1',   //话题
    GLOBAL_ARTICLE = '2', //文章
    GLOBAL_RECIPES = '3', //食谱 
    GLOBAL_COURSE = '4',  //课程    
    GLOBAL_COMMENT = '5'; //评论



var APP = {
    rootDir: /(widget)|(hongbei)|(A\d{6,}\/)/igm,

    // 获取当前文件相对根目录地址
    url: function(){
        var _url = location.href;
        var _path = _url.match( this.rootDir )[0];
        return _url.substring( _url.indexOf( _path ) + _path.length + 1, _url.indexOf( '.html' ) );
    },

    // 相对与跟目录层级
    relativeUrl: function(){
        var _num = this.url().match( /\//g );
        return _num ? (function(){
            var _path = '';
            for( var x in _num ){
                _path+='../';
            };
            return _path;
        })() : './'
        // return .length;
    },

    // 获取当前文件名称
    name: function(){
        var _name = this.url().split( '/' );
        return {
            name: _name[ _name.length - 1 ].split( '.' )[0],
            folder: _name[ _name.length - 2 ]  
        };
    },

    // 获取当前窗口属性
    properties: function(){
        var _name = this.name().name.split( '_' ),
            _css = document.querySelector( 'link[src]' );
        return {
            hasWin: _name[ _name.length - 1 ] === 'win',
            // name: typeof CSSFile === 'undefined' ? _name[0] : CSSFile
            styleName: _css ? _css.getAttribute( 'src' ) : _name[0]
        };
    },

    // 字段是否为空
    hasEmp: function( val ){
        return typeof val !== 'undefined';
    },

    // 获取当前窗口样式文件
    style: function(){
        return '<link rel="stylesheet" type="text/css" href="'+this.relativeUrl()+'css/'+this.properties().styleName+'.css" />'
    },

    fixIos7Bar: function(el) {
        var strDM = api.systemType;
        if (strDM == 'ios') {
            var numSV = parseInt(api.systemVersion, 10);
            var fullScreen = api.fullScreen;
            var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
            if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
                el.style.paddingTop = '20px';
            }
        }
    },
    
    fixStatusBar: function(el) {
        var sysType = api.systemType;
        if (sysType == 'ios') {
            this.fixIos7Bar(el);
        } else if (sysType == 'android') {
            var ver = api.systemVersion;
            ver = parseFloat(ver);
            if (ver >= 4.4) {
                el.style.paddingTop = '25px';
            }
        }
    },

    loadSuccess: function( cb ){
    	var angApp = angular.module('myApp', []);
		angApp.filter('dateFormat', ['$sce', function ($sce) {
		    return function ( _date ) {
		        if( _date instanceof Array ){
		            return new Date( +_date[0] * 1000 ).Format( _date[1] );
		        }else{
		            return new Date( +_date * 1000 ).Format( 'yyyy/MM/dd hh:mm' );   
		        }
		    };
		}]);

        angApp.filter('fnCache', ['$sce', function ($sce) {
            return function( _selector ) {
                return fnImgCache( $( _selector ) );
            };
        }]);
        
        angApp.filter('toHTML', ['$sce', function ($sce) {
            return function (txt) {
                return $sce.trustAsHtml(txt);
            };
        }]);
        angApp.directive('contenteditable', function() {
          return {
            require: 'ngModel',
            link: function(scope, element, attrs, ctrl) {
              // view -> model
              element.bind('blur', function() {
                scope.$apply(function() {
                  ctrl.$setViewValue(element.text());
                });
              });
         
              // model -> view
              ctrl.$render = function() {
                element.html(ctrl.$viewValue);
              };
            }
          };
        });

        // angApp.filter('unique',function(){
        // 　　return function(collection, keyname){
        // 　　　　var output = [];
        // 　　　　var _keys = [];
        // 　　　　angular.forEach(collection, function(item){
        // 　　　　　　var key = item[keyname];
        // 　　　　　　if(_keys.indexOf(key) === -1){
        //             _keys.push(key);
        //             output.push(item);
        // 　　　　　　}
        // 　　　　});
        // 　　　　return output;
        // 　　}
        // })

        
		angInit = function($scope, $http, $location, $timeout){
            $scope.fnResetTouchstart = function(){
                $( '[ng-click]' ).forEach(function(el){
                     $( el ).bind("touchstart", function(event){ 
                        $(el).addClass( 'hover' );
                      });
                     $( el ).bind("touchmove", function(event){
                        $(el).removeClass( 'hover' );
                      });
                     $( el ).bind('touchend', function(event){
                        $(el).removeClass( 'hover' );
                        $(el).removeAttr('ng-click');
                        $scope.$apply($(el).attr('ng-click'));  
                      });
                });
            }

            $scope.fnOpen = function( _path, hasLogin, _body ){
                _path = _path.split( '/' );
                var _param = {
                        name: _path[1],
                        folder: _path[0],
                        bgColor: _path[2],
                        pageParam: {},
                        hasLogin: hasLogin
//                      debug:true
                    };
                if( _body ){
                    _param.pageParam = _body;
                }
                if( _path[3] ){
                    _param.pageParam[ _path[3] ] = $scope[ _path[3] ];
                }
                fnOpenWin( _param );
            }

            $scope.fnTypeJump = function( _path, hasLogin, _body ){
                switch( this.current.id_type ){
                    case GLOBAL_TOPIC: 
                        $scope.fnOpen('community/communityDetail_win', false, {
                            topic_id: this.current.id
                        });
                    break;
                    case GLOBAL_ARTICLE: 
                        $scope.fnOpen('health/detail_win', false, {
                            article_id: this.current.id
                        });
                    break;
                    case GLOBAL_RECIPES: 
                        $scope.fnOpen('book/bookDetail_win', false, {
                            cookbook_id: this.current.id
                        });
                    break;
                    case GLOBAL_COURSE: 
                        $scope.fnOpen('classroom/videoDetail_win', false, { 
                            course_id: this.current.id
                        });
                    break;
                }
            }        

            
            $scope.fnSubmitCommunity = function(){
                fnOpenWin({
                    name: 'option_frm',
                    folder: 'public',
                    bgColor: 'rgba(0, 0, 0, 0)',
                    pageParam: {
                        top: $( 'header.show .top' ).height()
                    },
                    animation: {
                        type: 'none'
                    }
                })
            }

            $scope.sharefn = function(e){
                var dialogBox = api.require('dialogBox');
                dialogBox.share({
                    rect: {
                        w: api.winWidth - 10,
                        h: api.winHeight / 2
                    },
                    items: [{
                        text: '微信好友',
                        icon: 'widget://image/share_icon/wx_session.png'
                    },{
                        text: '微信朋友圈',
                        icon: 'widget://image/share_icon/wx_timeline.png'
                    }, {
                        text: 'QQ好友',
                        icon: 'widget://image/share_icon/qq_QFriend.png'
                    }, {
                        text: 'QQ空间',
                        icon: 'widget://image/share_icon/qq_QZone.png'
                    }, {
                        text: '微博',
                        icon: 'widget://image/share_icon/sina.png'
                    }],
                    styles: {
                        bg: '#FFF',
                        column: 4,
                        horizontalSpace: 4,
                        verticalSpace: 30,
                        itemText: {
                            color: '#000',
                            size: 14,
                            marginT: 10
                        },
                        itemIcon: {
                            size: 50
                        }
                    },
                    tapClose: true
                }, function(ret) {
                    dialogBox.close({
                        dialogName: 'share'
                    });
                    if ( ret.index == 0 ) {
                        wx('session');
                    }else if ( ret.index == 1 ) {
                        wx('timeline');
                    }else if ( ret.index == 2 ){
                        qq('QFriend');
                    }else if ( ret.index == 3 ){
                        qq('QZone');
                    }else if ( ret.index == 4 ) {
                        weibo('');
                    }
                });
                // 微信相关
                function wx(type){
                    var wx = api.require('wx');
                    wx.isInstalled(function(ret, err) {
                        if (!ret.installed) {
                            fnToast("当前设备未安装微信客户端");
                        }else{
                            fnShowProgress('连接微信中');
                            wx.shareWebpage({
                                scene: type || 'timeline',
                                title: e.title || '微信分享测试标题',
                                description: e.description || '',
                                thumb: 'widget://image/share_icon/wx_timeline.png',
                                contentUrl: e.contentUrl || ''
                            }, function(ret, err) {
                                api.hideProgress();
                                if (ret.status) {
                                    shareOk();
                                }else{
                                    shareNo();
                                }
                            });
                        }
                    });
                }
                // qq相关
                function qq(type){
                    var qq = api.require('qq');
                    qq.installed(function(ret,err){
                        if ( !ret.status ) {
                            fnToast("当前设备未安装QQ客户端");
                        }else{
                            fnShowProgress('连接QQ中');
                            qq.shareNews({
                                url: e.contentUrl || '',
                                title: e.title || '',
                                description: e.description || '',
                                imgUrl: e.imageUrl || 'widget://image/share_icon/qq_QZone.png',
                                type: type || 'QZone'
                            },function(ret, err){
                                api.hideProgress();
                                if ( ret.status ) {
                                    shareOk();
                                }else{
                                    shareNo();
                                }
                            });
                        }
                    });
                }
                // 新浪微博相关
                function weibo(){
                    var weibo = api.require('weibo');
                    weibo.isInstalled(function(ret) {
                        if (!ret.status) {
                            fnToast('当前设备未安装微博客户端');
                        }else{
                            fnShowProgress('连接微博中');
                            weibo.shareWebPage({
                                text: e.title || '微博分享测试的内容',
                                title: e.title || '微博分享测试标题',
                                description: e.description || '微博分享内容的描述',
                                thumb: e.imageUrl || 'widget://image/share_icon/sina.png',
                                contentUrl: e.contentUrl || ''
                            }, function(ret, err) {
                                api.hideProgress();
                                if (ret.status) {
                                    shareOk();
                                }else{
                                    shareNo();
                                }
                            });
                        }
                    });
                }
                function shareOk(){
                    fnToast('分享成功');
                }
                function shareNo(){
                    fnToast('分享失败');
                }
            }

            $scope.NUM_TEMP = 10,
            $scope.NUM = $scope.NUM_TEMP,
            $scope.PAGE = 1;


            $scope.fnSetVal = function( name, value, cb){
                $timeout(function(){
                    var _names = name.split('.');
                    if( _names.length == 2 ){
                        $scope[ _names[0] ][ _names[1] ] = value;
                    }else{
                        $scope[ _names[0] ] = value;
                    }
                    cb && cb( value );
                }, 10);
            }

            $scope.fnResetLayout = function(){
                // apiready();
                window.USER = localStorage.getItem( 'USER' ) && JSON.parse( localStorage.getItem( 'USER' ) );
                window.$timeout = $timeout;
                $scope.fnSetVal( 'win', window);
                window.$scope = $scope;
            }
            
            apiready = function(){
                var _header = $( 'header' )[0] || $( '.header' )[0];
                api.addEventListener({
                    name: 'ev_login'
                }, function(ret, err) {
                    $scope.fnResetLayout();
                });
                if( _header ){
                    APP.fixIos7Bar( $( _header )[0] );
                }
                for( var x in api.pageParam ){
                    $scope.fnSetVal( x, api.pageParam[x]);
                }
                $timeout(function(){
                    $scope.fnResetLayout();
                    $scope.fnResetTouchstart();
                    $scope.body = api.pageParam;
                    cb && cb( $scope, $timeout);
                }, 100);
            }
                // cb && cb( $scope, $timeout);
        }
    }

};

document.head.insertAdjacentHTML('beforeend', APP.style());

var vGlobalInput = null;
function fnInput( el, selector ){
    vGlobalInput = el;
    if( $.trim( $( el ).val() ).length ){
        if( ! $( el ).parent().find( '.ic_input_close' ).length ){
            $( el ).parent().append( '<div tapmode onclick="fnEmptyInput( this );" class="ic_input_close"></div>' );
        }
        if( selector ){
            $( selector ).html( $( el ).attr( 'data-num' ) - $.trim( $( el ).val() ).length )
        }
    }else{
        $( el ).parent().find( '.ic_input_close' ).remove();
    }
}

function fnSetGroScroll( _name, _hasScroll){
    api.setFrameGroupAttr({
        name: _name,
        scrollEnabled: _hasScroll || false
    });
}

function fnEmptyInput( el ){
    event.stopPropagation();
    $( vGlobalInput ).val( '' )
    fnInput( $( vGlobalInput )[0] )
}

// function fnOpen( el ){
// 	var _path = $( el ).attr( 'data-path' ).split( '/' );
//     fnOpenWin({
//         name: _path[1],
//         folder: _path[0],
//         bgColor: _path[2]
//     });
// }
    

function fnShowProgress( _txt ){
    api.showProgress({
        style: 'default',
        animationType: 'fade',
        title: _txt,
        text: '请稍后...',
        modal: true
    });
}

    
// fnOpenWin({
//     name: 'win',
//     folder: 'folder',
//     bgColor: '#fff',
// })
function fnOpenWin( obj ){
    function _fn(){
        if( ! obj.name ){
            obj.name = api.winName.replace( /_win$/, '_frm');
            obj.folder = APP.name().folder;
        }
        var vParam = {
            name: obj.name,
            url: obj.url || 'widget://html/' + obj.folder + '/' + obj.name + '.html',
            pageParam: obj.pageParam || api.pageParam,
            delay: obj.delay || 0,
            bgColor: obj.bgColor || api.pageParam.bgColor || '#f0f0f0',
            animation: obj.animation || {
                type: 'movein',
                subType: 'from_right',
                duration: 300
            }
        };
        if( /_frm$/g.test( obj.name ) ){
            vParam.progress = {
                type: 'default',
                color: '#ff0'
            };
            vParam.animation = obj.animation || {
                type: 'movein',
                subType: 'from_bottom',
                duration: 300
            };
            vParam.allowEdit = true;
            obj.rect && (vParam.rect = obj.rect);
            api.openFrame( vParam );
        }else{
            vParam.pageParam.prvWin = {
                winName: api.winName,
                frameName: api.frameName
            };
            vParam.pageParam.bgColor = vParam.bgColor;
            api.openWin( vParam );
        }
        if( obj.debug )debugAlert( obj.name, '::', vParam );
    }
    if( obj.hasLogin && ! USER ){
        fnHasLogin( _fn );
    }else{
        _fn();
    }

//  }
}


function fnHasLogin(cb){
    if( USER ){
        cb( USER );
    }else{
        // api.addEventListener({
        //     name: 'ev_login'
        // }, function(ret, err) {
            $scope.fnResetLayout();
        //     cb();
        // });
        fnOpenWin({
            name: 'login_win',
            folder: 'person',
            bgColor: '#fff'
        });
    }
}



function debugAlert(){
    if( true ){
        var vTemp = []; 
        for( var x in arguments ){
            vTemp.push( arguments[x] );
        }
        vTemp = JSON.stringify( vTemp );
        vTemp = vTemp.substring( 1, vTemp.length-1);
        console.log( vTemp );
        return vTemp;
    }
}


function fnToast( _txt, cb){
    if( window.api ){ 
        api.toast({
            msg: _txt
        });
        setTimeout(function(){
            cb && cb( _txt );
        }, 1000);
    }else{
        // alert( _txt );   
    }
}

function fnEmpty(){
    fnToast( '该功能尚未开放' );
}

function fnCookie(_key, _value, cb){
    if( typeof _value != 'undefined' ){
        localStorage.setItem( _key, JSON.stringify( _value ) );
    }else{
        var _result = localStorage.getItem( _key ) && JSON.parse( localStorage.getItem( _key ) );
        cb && cb( _result );
        return _result;
    }
}

function fnRmCookie(_key, cb){
    var _result = localStorage.removeItem( _key );
    cb && cb( _result );
}

// 验证
function fnVerify( type ) {
    if( type === 'Email' ){
        return /^(\w-*\.*)+@(\w-?)+(\.\w{2,})+$/;
    }else if( type === 'Phone' ){
        return /^1\d{10}$/;
    }else if( type === 'Tel' ){
        return /^0\d{2,3}-?\d{7,8}$/;
    }
};


// 验证
function fnGetVerifyType( _type ) {
    if( _type === 'Email' ){
        return /^(\w-*\.*)+@(\w-?)+(\.\w{2,})+$/;
    }else if( _type === 'Phone' ){
        return /^1\d{10}$/;
    }else if( _type === 'Tel' ){
        return /^0\d{2,3}-?\d{7,8}$/;
    }
};


function fnAjax( obj, cb){
    typeof obj.progress === 'undefined' && api.showProgress({
        title: '加载中...',
        text: '请稍后...',
        modal: true
    });
    var vParam = {
        url: obj.url2 || 'http://www.ambaker.cn/api/'+obj.url,
        method: obj.method || ( obj.data ? 'post' : 'get' ),
        timeout: obj.timeout || 30,
        data: {
            values: obj.data && obj.data.body,
            files: obj.data && obj.data.files
        }
    }
    if( obj.debug )debugAlert( obj.url,'--->', vParam );
    var signature = api.require('signature');
    signature.sha1({
        data: JSON.stringify( vParam )
    }, function(ret, err) {
        if (ret.status) {
            api.ajax(vParam, function (ret, err) { 
                    if( obj.debug )debugAlert( obj.url,'--->', arguments );
                api.hideProgress();
                api.refreshHeaderLoadDone();
                if( ret ){
                    cb( ret );
                }else{
                    // alert( obj.url+'--->'+JSON.stringify( err ))
                    alert( '网络连接异常' )
                }
            });
        }
    });
    // var _param = {
    //     type: obj.method || ( obj.data ? 'POST' : 'GET' ),
    //     url: 'http://www.ambaker.cn/api/'+obj.url,
    //     // post payload:
    //     data: obj.data,
    //     dataType: 'json',
    //     success: function( success ){
    //         obj.debug && console.log( arguments );
    //         window.$timeout(function(){
    //             cb && cb( success );
    //         }, 10);
    //     },
    //     error: function( err ){
    //         obj.debug && console.log( arguments );
    //         window.$timeout(function(){
    //             cb && cb( err );
    //         }, 10);
    //     }
    // };
    // obj.debug && console.log( _param );
    // $.ajax(_param);
    // api.ajax(_param, function(ret, err) {
    //     if (ret) {
    //         api.alert({ msg: JSON.stringify(ret) });
    //     } else {
    //         api.alert({ msg: JSON.stringify(err) });
    //     }
    // });
}

function fnLanguage( _val ){
    return _val;
}

function fnSelector ( _title, _data, cb, debug){
    var scope = [[],[],[]];
    for( var x in _data ){
        _data[x].value = _data[x].city_name;
        _data[x].parentId = _data[x].city_parent_id;
        _data[x].id = _data[x].city_id;
        if( _data[x].city_type == 1 ){
            scope[0].push( _data[x] );
        }else if( _data[x].city_type == 2 ){
            scope[1].push( _data[x] );
        }
    }
    // if( _data instanceof Array ){
    //     for( var x in _data ){
    //         if( 'city_name' in _data[x] ){
    //             _data[x].value = _data[x].city_name;
    //         }
    //     }
    // }

    // if( debug )console.log( JSON.stringify( _data ) );
    console.log( scope )
    new IosSelect(2, scope,{
        container: 'body',
        title: _title,
        itemHeight: 50,
        relation: [1, 1],
        // itemShowCount: 3,
        endback: function( ret ){
            console.log( ret )
        },
        callback: function ( ret ) {
            // cb && cb( ret );
            console.log( ret, $( '.iosselect-box li.at') )
        }
    });
};


    // 获取图片
    function fnGetPicture( cb ) {
        api.actionSheet({
            cancelTitle: fnLanguage( '取消' ),
            buttons: [ fnLanguage( '拍照上传' ), fnLanguage( '手机相册' )]
        }, function (ret, err) {
            var _type = 'library';
            if (ret.buttonIndex == 1) {
                _type = 'camera';
            }
            
            if( ret.buttonIndex !== 3 ){
                api.getPicture({
                  sourceType: _type,
                  encodingType: 'png',
                  mediaValue: 'pic',
                  destinationType: 'url',
                  allowEdit: true,
                  targetWidth: 800,
                  targetHeight: 800,
                  quality: 50,
                  saveToPhotoAlbum: false
              }, function (ret, err) {
                  if (ret && ret.data) {
                      fnAjax({
                        url: 'public/uploadImg',
                        data: {
                            files: {
                                file: ret.data
                            }
                        },
                        debug: true
//                          progress: true 
                    }, function( res ){
                        if( Number( res.status ) ){
                            fnToast( res.message );
                        }else{
                            res.locationFile = ret.data;
                            cb( res );
                        }
                    });
                  }
              });
            }
        });
    }

function fnGetInfo( _data, hasJump ){
    fnAjax({
        url: 'user/userInfo',
        data: {
            body: {
                uiCode: _data.uiCode
            }
        },
        debug: true
    }, function( res ){
        debugAlert( Number( res.status ) )
        debugAlert( !! Number( res.status ) )
        debugAlert( res.status  )

        debugAlert( !! res.status  )
         if( Number( res.status ) ){
            fnToast( res.message );
         }else{
            _data.info = res.data;
            localStorage.setItem( 'USER', JSON.stringify( _data ) );
            api.sendEvent({
                name: 'ev_login',
                extra: _data
            });
            if( ! hasJump ){
                fnToast( '稍后…', function(){
                    api.closeWin();
                });
            }
         }
    }); 
}


function fnImgCache(el, debug){
    setTimeout(function(){
        var url = el.attr('data-url');
        if( url ){

            if( el[0].tagName === 'IMG' ){
                el.parent().addClass('img-cache');
                el.parent().attr('data-img-cache', 0);
            }else{
                el.addClass('img-cache');
                el.attr('data-img-cache', 0);
            }
            api.download({
                url: url,
                encode: false,
                // savePath: 'fs://test.rar',
                report: true,
                cache: true,
                allowResume: true
            }, function(ret, err){
                if( debug )debugAlert( url, '--->', arguments );
                if (ret.state == 1) {
                    el.removeAttr('data-url');
                    el.attr('data-photoBrowser', ret.savePath);
                    if( el[0].tagName === 'IMG' ){
                        el.attr('src', ret.savePath);
                        el.parent().removeAttr('data-img-cache');
                        el.parent().removeClass('img-cache');
                    }else{
                        el.removeAttr('data-img-cache');
                        el.removeClass('img-cache');
                        el.css('background-image', 'url('+ret.savePath+')');
                    }
                }else if(ret.state == 0){
                    el.attr('data-img-cache', ret.percent);
                    el.parent().attr('data-img-cache', ret.percent);
                }else{

                }
            });

            // window.api && api.imageCache({
            //     url: url,
            //     policy: 'cache_else_network',
            //     encode: false,
            //     thumbnail: true
            // }, function(ret, err){
            //     if( debug )debugAlert( arguments );
            //     if ( ret && ret.status && ret.url) {

            //     }
            // }); 
        }
    }, 10);
};



function fnPhotoBrowser( el, _parent ){
    event.stopPropagation();
    var _pics = [],
        imageBrowser = api.require('imageBrowser'),
        index = $( el ).index();
        if( _parent ){

        }else{
            _parent = $( el ).parent();
        }
    _parent.find( '[data-photoBrowser]' ).forEach(function( _element, _index ){
        var _url = $( _element ).attr('data-photoBrowser');
        if( el === _element ){
            index = _index;
        }
        if( _url !== 'undefined' ){
            _pics.push(_url);
        };
    });
    if( _pics.length ){
        imageBrowser.openImages({
            imageUrls: _pics,
            activeIndex: index
        });
    }
}

function fnRefresh( cb ){
    api.setRefreshHeaderInfo({
        visible: true,
        loadingImg: 'widget://image/refresh.png',
        bgColor: '#ccc',
        textColor: '#fff',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: true
    }, function(ret, err) {
        cb();
    });
}

Date.prototype.Format = function (fmt) { //author: meizz
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
};